<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>The Tree to ElementList transformation principles</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="CREATED" CONTENT="20070928;11000900">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20070928;11000900">
</HEAD>
<BODY LANG="fr-FR" BGCOLOR="#ffffff" DIR="LTR">
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>The Tree to ElementList
transformation principles</FONT></FONT></H1>
<P>Let “<I>MMTree</I>” be the tree meta model's name and
“<I>MMElementList</I>” be the ElementList meta models' name.</P>
<P>In this transformation, we want :</P>
<UL>
	<LI><P>the tree root (of type <I>MMTree!Node</I>) to be transformed
	into the Element list “root” (of type <I>MMElementList!RootElement</I>)</P>
	<LI><P>a <I>MMTree!Leaf</I> element should be transformed into an
	<I>MMElementList!CommonElement</I> element</P>
	<LI><P>the <I>MMElementList!RootElement</I>'s “elements”
	attribute should contain an <B>ordered set</B> composed of the
	“transformed equivalent” of the leaves such as :</P>
	<UL>
		<LI><P>all big sized leaves comes first (in the tree's DFS order)</P>
		<LI><P>then all medium sized leaves (still in the tree's DFS order)</P>
		<LI><P>then the small sized one (still in the tree's DFS order)</P>
	</UL>
</UL>
<P>The figure below instantiates a transformation example. The nodes'
names are represented by an integer and the tree root is named “0”.</P>
<P><IMG SRC="../img/schema.png" NAME="graphics5" ALIGN=LEFT WIDTH=642 HEIGHT=196 BORDER=0><BR CLEAR=LEFT>We
can easily see the biggest part of this transformation is to “build”
the “elements” attribute of the <I>MMElementList!RootElement</I>
object.</P>
<P>With a common imperative algorithm, we would use a recursive
function on the tree root's children which would build three
<I>MMElementList!CommonElement</I> list corresponding to the small,
medium and big leaves encoutered during the DFS. Briefly, the
algorithm would :</P>
<UL>
	<LI><P>test the current child type (node or leaf)</P>
	<LI><P>if it is a node, make a recursive call,</P>
	<LI><P>else, test the leaf size and create a
	<I>MMElementList!CommonElement</I> with the leaf's name as its own
	name. According to the leaf size, this new object would be queued in
	the matching list (big sized leaf, medium or small)</P>
</UL>
</BODY>
</HTML>